﻿/*

@Many code parts and items are taken from Google Video Gadget. Many thanks to its Author.

YouTube RSS link for a tag:
	http://www.youtube.com/rss/tag/fener%20opera.rss
	http://www.youtube.com/rss/tag/ + SEARCHBOX VALUE + .rss

thumbnail 130 x 97
swf 450 x 370

*/

var RSSLINK_PREFIX = "http://www.youtube.com/rss/tag/";
var RSSLINK_SUFFIX = ".rss";
var DEFAULT_RSSURL = "http://youtube.com/rss/global/top_viewed_today.rss"

// Video Object control
var detailsControl = null;

// Index for RSS "item" nodes and so thumbArray, titleArray, ...
var index = 0; 
// User
var tag = "";

var thumbArray = null;
var titleArray = null;
var linkArray  = null;
var descArray  = null;
var swfArray  = null;

contentArea.contentFlags = gddContentFlagHaveDetails;


function Initialize()
{
	loadData(DEFAULT_RSSURL);
}


// gets data according to user's input for the search
function getVideoData() 
{
	if (event.keycode == 13) 
	{ 
		if (searchBox.value != "") 
		{
			tag = searchBox.value;
			searchBox.value = "Loading... ";
			loadData(getRSSLink(tag));
		}
	} 
}

// loads data from the specified URL
function loadData(url) 
{
	http = new XMLHttpRequest();
	http.onreadystatechange = afterResponse;
	http.open("GET", url, true);
	http.setRequestHeader('Pragma', "no-cache");
	http.send();

	function afterResponse()
	{
		if (http.readyState == 4) 
		{
		    searchBox.value = tag;
		    if (http.status != 200) 
		    {	
			alert(CONNECTION_ERROR_MESSAGE + "\n" + url);
			return;
		    }

			
			var doc = new DOMDocument();
			
			doc.loadXML(http.responseText);
			
			Tags = doc.getElementsByTagName("item");
			
			if (Tags == null || Tags.length <= 0) 
			{
				alert(NOANSWER_ERROR_MESSAGE + "\n" + url);
				return;
			}
			
			thumbArray = new Array();
			linkArray = new Array();
			titleArray = new Array();
			descArray = new Array();
			swfArray = new Array();
		  
			try {
				for(i = 0; i < Tags.length; i++) 
				{
					var title ="";
					var link ="";
					var desc ="";
					var swf ="";
					var thumb ="";
					
					// for each item
					for (var node = Tags[i].firstChild; node != null; node = node.nextSibling) 
					{
						if (node.nodeName == "title")
							title = node.firstChild.nodeValue;
						if (node.nodeName == "link")
							link = node.firstChild.nodeValue;
						if (node.nodeName == "description")
							desc = node.firstChild.nodeValue;
						if(node.prefix == "media" && node.baseName == "thumbnail")
							thumb = node.attributes.getNamedItem("url").value;
						if (node.nodeName == "enclosure")
							swf = node.attributes.getNamedItem("url").value;					
					}
					thumbArray.push(thumb);
					titleArray.push(title);
					linkArray.push(link);
					descArray.push(desc);
					swfArray.push(swf);
			
				}
			} catch(e)
			{
				alert(UNDEFINEDXMLTAG_ERROR_MESSAGE + "\n" + url);
				return;
			}
			delete http;
			delete doc;
			drawItem();
			
		}
	}
}

// draws the thumbnail and details object for the active item node(taken from the arrays with index "index")
function drawItem()
{
    var http = new XMLHttpRequest();
    http.onreadystatechange = afterVideoStream;  
    http.open("GET",thumbArray[index],true);
    http.setRequestHeader('Pragma', "no-cache");
    http.send();

    function afterVideoStream() {
 
		if (http.readyState == 4) 
		{
			if (http.status != 200)	return;

			contentArea.removeAllContentItems();
			
			var thumbObject = new ContentItem();
			videoTitle.innerText = titleArray[index];
			thumbObject.layout = gddContentFlagManualLayout;
			thumbObject.image = utils.loadImage(http.responseStream);
			thumbObject.tooltip = THUMB_TOOLTIP_PREFIX + "\n" + titleArray[index];
			thumbObject.onDrawItem = PictureOnDrawItem;
			thumbObject.onGetHeight = GetItemHeight;
			thumbObject.heading = titleArray[index];
			thumbObject.flags = gddContentItemFlagPinned + gddContentItemFlagNoRemove;
			thumbObject.snippet = "<div style=\"position:absolute; width=\"500\"; height=\"400\" top:0; left:0; border:1px solid white; z-index:2;\">" 
							+ "<embed style=\"width:450px; height:370px;\" id=\"VideoPlayback\" align=\"middle\" type=\"application/x-shockwave-flash\" src=\"" + swfArray[index] + "\" quality=\"best\" bgcolor=\"#ffffff\" scale=\"noScale\" salign=\"TL\" FlashVars=\"playerMode=embedded\"> </embed>"
							+ "<br>" + descArray[index] + "<br>"
							+ "</div>";
			thumbObject.onDetailsView = OnDetailsView;
			thumbObject.open_command = linkArray[index];
			contentArea.addContentItem(thumbObject, gddItemDisplayInSidebar); 		
		} 
		if(http != null) delete http;
   }

}

// thumb object onDetailsView event
function OnDetailsView(item)
{	    
            var detailsHTML = "<html><head><style type=\"text/css\"> body{font-family:arial,sans-serif; font-size: 10px; margin-left: 0px; margin-top: 0px; margin-right: 0px; margin-bottom: 0px;}</style></head><body>";
            detailsHTML += item.snippet;
            detailsHTML += "<br /><br /></body></html>";
            
            detailsControl = new DetailsView();		
            detailsControl.SetContent("YouTube Video", 0, detailsHTML, true, item.layout);
            detailsControl.html_content = true;

	    var details = new Object();
            details.details_control = detailsControl;
            details.flags = gddDetailsViewFlagToolbarOpen;
	    
            return details;
} 

// thumb object onGetHeight event
function GetItemHeight(item, target, graphics, width) 
{
	return contentArea.height - 6; 
}

// thumb object onDrawItem event
function PictureOnDrawItem(item, target, graphics, x, y, width, height) {
	
  graphics.DrawImage(x, y, contentArea.width - 2,
  contentArea.height-5, item.image, 100);
}

// returns the URL of the RSS according to user's input
function getRSSLink(userTag) 
{
     var strReplaceAll = userTag;
     var intIndexOfMatch = strReplaceAll.indexOf( " " );
      
     // Loop over the string value replacing out each matching
     // substring.
     while (intIndexOfMatch != -1){
     // Relace out the current instance.
	strReplaceAll = strReplaceAll.replace( " ", "%20" )
      
     // Get the index of any next matching substring.
	intIndexOfMatch = strReplaceAll.indexOf( " " );
     }

     return RSSLINK_PREFIX + strReplaceAll + RSSLINK_SUFFIX;
}

//click event for the previous button. Sets the active index to index-1 if exists
function prevOnClick()
{
    if (index > 0) --index;
    else return;

    drawItem();
}

//click event for the next button. Sets the active index to index+1 if exists
function nextOnClick()
{
    if (index < thumbArray.length -1 ) index++; 
    else return;

    drawItem();
}
